﻿// <auto-generated> This file has been auto generated by EF Core Power Tools. </auto-generated>
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;
using MundoCalcado.Domain.Entities;

namespace MundoCalcado.Domain
{
    public partial class MundoCalcadoDbContext : DbContext
    {
        public MundoCalcadoDbContext()
        {
        }

        public MundoCalcadoDbContext(DbContextOptions<MundoCalcadoDbContext> options)
            : base(options)
        {
        }

        public virtual DbSet<Category> Category { get; set; }
        public virtual DbSet<Color> Color { get; set; }
        public virtual DbSet<ProdColor> ProdColor { get; set; }
        public virtual DbSet<Product> Product { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<ProdColor>(entity =>
            {
                entity.Property(e => e.IdProdColor).ValueGeneratedOnAdd();

                entity.HasOne(d => d.Color)
                    .WithOne(p => p.ProdColor)
                    .HasForeignKey<ProdColor>(d => d.IdProdColor)
                    .OnDelete(DeleteBehavior.ClientSetNull)
                    .HasConstraintName("FK_Color_ProdColor");

                entity.HasOne(d => d.Product)
                    .WithOne(p => p.ProdColor)
                    .HasForeignKey<ProdColor>(d => d.IdProdColor)
                    .OnDelete(DeleteBehavior.ClientSetNull)
                    .HasConstraintName("FK_Product_ProdColor");
            });

            modelBuilder.Entity<Product>(entity =>
            {
                entity.HasOne(d => d.IdCategoryNavigation)
                    .WithMany(p => p.Product)
                    .HasForeignKey(d => d.IdCategory)
                    .OnDelete(DeleteBehavior.ClientSetNull)
                    .HasConstraintName("FK_Product_Category");
            });

            OnModelCreatingPartial(modelBuilder);
        }

        partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
    }
}